subtree-merge https://github.com/hannob/bashcheck plus my bash 2.05b patch
authorThorsten Glaser <t.glaser@tarent.de>
Tue, 7 Jul 2015 13:15:17 +0000 (15:15 +0200)
committerThorsten Glaser <t.glaser@tarent.de>
Tue, 7 Jul 2015 13:15:17 +0000 (15:15 +0200)
bash/bashcheck/LICENSE [new file with mode: 0644]
bash/bashcheck/README.md [new file with mode: 0644]
bash/bashcheck/bashcheck [new file with mode: 0755]

diff --git a/bash/bashcheck/LICENSE b/bash/bashcheck/LICENSE
new file mode 100644 (file)
index 0000000..670154e
--- /dev/null
@@ -0,0 +1,116 @@
+CC0 1.0 Universal
+
+Statement of Purpose
+
+The laws of most jurisdictions throughout the world automatically confer
+exclusive Copyright and Related Rights (defined below) upon the creator and
+subsequent owner(s) (each and all, an "owner") of an original work of
+authorship and/or a database (each, a "Work").
+
+Certain owners wish to permanently relinquish those rights to a Work for the
+purpose of contributing to a commons of creative, cultural and scientific
+works ("Commons") that the public can reliably and without fear of later
+claims of infringement build upon, modify, incorporate in other works, reuse
+and redistribute as freely as possible in any form whatsoever and for any
+purposes, including without limitation commercial purposes. These owners may
+contribute to the Commons to promote the ideal of a free culture and the
+further production of creative, cultural and scientific works, or to gain
+reputation or greater distribution for their Work in part through the use and
+efforts of others.
+
+For these and/or other purposes and motivations, and without any expectation
+of additional consideration or compensation, the person associating CC0 with a
+Work (the "Affirmer"), to the extent that he or she is an owner of Copyright
+and Related Rights in the Work, voluntarily elects to apply CC0 to the Work
+and publicly distribute the Work under its terms, with knowledge of his or her
+Copyright and Related Rights in the Work and the meaning and intended legal
+effect of CC0 on those rights.
+
+1. Copyright and Related Rights. A Work made available under CC0 may be
+protected by copyright and related or neighboring rights ("Copyright and
+Related Rights"). Copyright and Related Rights include, but are not limited
+to, the following:
+
+  i. the right to reproduce, adapt, distribute, perform, display, communicate,
+  and translate a Work;
+
+  ii. moral rights retained by the original author(s) and/or performer(s);
+
+  iii. publicity and privacy rights pertaining to a person's image or likeness
+  depicted in a Work;
+
+  iv. rights protecting against unfair competition in regards to a Work,
+  subject to the limitations in paragraph 4(a), below;
+
+  v. rights protecting the extraction, dissemination, use and reuse of data in
+  a Work;
+
+  vi. database rights (such as those arising under Directive 96/9/EC of the
+  European Parliament and of the Council of 11 March 1996 on the legal
+  protection of databases, and under any national implementation thereof,
+  including any amended or successor version of such directive); and
+
+  vii. other similar, equivalent or corresponding rights throughout the world
+  based on applicable law or treaty, and any national implementations thereof.
+
+2. Waiver. To the greatest extent permitted by, but not in contravention of,
+applicable law, Affirmer hereby overtly, fully, permanently, irrevocably and
+unconditionally waives, abandons, and surrenders all of Affirmer's Copyright
+and Related Rights and associated claims and causes of action, whether now
+known or unknown (including existing as well as future claims and causes of
+action), in the Work (i) in all territories worldwide, (ii) for the maximum
+duration provided by applicable law or treaty (including future time
+extensions), (iii) in any current or future medium and for any number of
+copies, and (iv) for any purpose whatsoever, including without limitation
+commercial, advertising or promotional purposes (the "Waiver"). Affirmer makes
+the Waiver for the benefit of each member of the public at large and to the
+detriment of Affirmer's heirs and successors, fully intending that such Waiver
+shall not be subject to revocation, rescission, cancellation, termination, or
+any other legal or equitable action to disrupt the quiet enjoyment of the Work
+by the public as contemplated by Affirmer's express Statement of Purpose.
+
+3. Public License Fallback. Should any part of the Waiver for any reason be
+judged legally invalid or ineffective under applicable law, then the Waiver
+shall be preserved to the maximum extent permitted taking into account
+Affirmer's express Statement of Purpose. In addition, to the extent the Waiver
+is so judged Affirmer hereby grants to each affected person a royalty-free,
+non transferable, non sublicensable, non exclusive, irrevocable and
+unconditional license to exercise Affirmer's Copyright and Related Rights in
+the Work (i) in all territories worldwide, (ii) for the maximum duration
+provided by applicable law or treaty (including future time extensions), (iii)
+in any current or future medium and for any number of copies, and (iv) for any
+purpose whatsoever, including without limitation commercial, advertising or
+promotional purposes (the "License"). The License shall be deemed effective as
+of the date CC0 was applied by Affirmer to the Work. Should any part of the
+License for any reason be judged legally invalid or ineffective under
+applicable law, such partial invalidity or ineffectiveness shall not
+invalidate the remainder of the License, and in such case Affirmer hereby
+affirms that he or she will not (i) exercise any of his or her remaining
+Copyright and Related Rights in the Work or (ii) assert any associated claims
+and causes of action with respect to the Work, in either case contrary to
+Affirmer's express Statement of Purpose.
+
+4. Limitations and Disclaimers.
+
+  a. No trademark or patent rights held by Affirmer are waived, abandoned,
+  surrendered, licensed or otherwise affected by this document.
+
+  b. Affirmer offers the Work as-is and makes no representations or warranties
+  of any kind concerning the Work, express, implied, statutory or otherwise,
+  including without limitation warranties of title, merchantability, fitness
+  for a particular purpose, non infringement, or the absence of latent or
+  other defects, accuracy, or the present or absence of errors, whether or not
+  discoverable, all to the greatest extent permissible under applicable law.
+
+  c. Affirmer disclaims responsibility for clearing rights of other persons
+  that may apply to the Work or any use thereof, including without limitation
+  any person's Copyright and Related Rights in the Work. Further, Affirmer
+  disclaims responsibility for obtaining any necessary consents, permissions
+  or other rights required for any use of the Work.
+
+  d. Affirmer understands and acknowledges that Creative Commons is not a
+  party to this document and has no duty or obligation with respect to this
+  CC0 or use of the Work.
+
+For more information, please see
+<http://creativecommons.org/publicdomain/zero/1.0/>
diff --git a/bash/bashcheck/README.md b/bash/bashcheck/README.md
new file mode 100644 (file)
index 0000000..5af18f6
--- /dev/null
@@ -0,0 +1,103 @@
+bashcheck
+=========
+
+Test script for Shellshock and related vulnerabilities
+
+background
+==========
+
+The Bash vulnerability that is now known as Shellshock had an incomplete
+fix at first. There are currently 6 public vulnerabilities.
+
+shellshock and heartbleed
+=========================
+
+I wrote down some general thoughts about recent events and security
+in free software:
+* https://blog.hboeck.de/archives/857-How-to-stop-Bleeding-Hearts-and-Shocking-Shells.html
+
+interpreting results
+====================
+
+There's been some confusion how to interpret the results of this script
+and some people got scared by warnings on systems that didn't have any
+exploitable bugs.
+
+The most important fix you need is one of the prefix/suffix-patches. Upstream
+patch number for this is bash042-050 and bash043-027 (patches for older
+versions also available). This patch was originally created by RedHat
+developer Florian Weimer and a modified version was applied by Bash
+developer Chet Ramey.
+
+Once you have this prefix patch all other vulnerabilities are not exploitable.
+They are still bugs that should be fixed, but there is nothing to worry
+about.
+
+
+usage
+=====
+
+Just run script:
+ `./bashcheck`
+
+CVE-2014-6271
+=============
+
+The original vulnerability.
+
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-6271
+
+CVE-2014-7169
+=============
+
+Further parser error, found by Tavis Ormandy (taviso).
+
+* https://twitter.com/taviso/status/514887394294652929
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-7169
+
+CVE-2014-7186
+=============
+
+Out of bound memory read error in redir_stack.
+
+* http://seclists.org/oss-sec/2014/q3/712
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-7186
+
+CVE-2014-7187
+=============
+
+Off-by-one error in nested loops.
+(check only works when Bash is built with -fsanitize=address)
+
+* http://seclists.org/oss-sec/2014/q3/712
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-7187
+
+CVE-2014-6277
+=============
+
+Uninitialized Memory use in make_redirect(), found by
+Michal Zalewski (lcamtuf).
+
+* http://lcamtuf.blogspot.de/2014/10/bash-bug-how-we-finally-cracked.html
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-6277
+
+CVE-2014-6278
+=============
+
+Another parser bug, analysis still incomplete, also found
+by Michal Zalewski (lcamtuf).
+
+* http://lcamtuf.blogspot.de/2014/10/bash-bug-how-we-finally-cracked.html
+* https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-6278
+
+Patch recommendation
+====================
+
+Latest upstream patches (4.3 since patchlevel 030, 4.2 since patchlevel 051)
+include all fixes.
+
+They also add prefixing to variable functions (a variant of Florian
+Weimer's patch). This protects from further function parser bugs and makes
+them likely not exploitable.
+
+My current recommendation: Use latest upstream patches.
diff --git a/bash/bashcheck/bashcheck b/bash/bashcheck/bashcheck
new file mode 100755 (executable)
index 0000000..4015c33
--- /dev/null
@@ -0,0 +1,91 @@
+#!/bin/bash
+
+warn() {
+       if [ "$scary" == "1" ]; then
+               echo -e "\033[91mVulnerable to $1\033[39m"
+       else
+               echo -e "\033[93mFound non-exploitable $1\033[39m"
+       fi
+}
+
+good() {
+       echo -e "\033[92mNot vulnerable to $1\033[39m"
+}
+
+tmpdir=`mktemp -d -t tmp.XXXXXXXX`
+
+[ -n "$1" ] && bash=$(which $1) || bash=$(which bash)
+echo -e "\033[95mTesting $bash ..."
+$bash -c 'echo "Bash version $BASH_VERSION"'
+echo -e "\033[39m"
+
+#r=`a="() { echo x;}" $bash -c a 2>/dev/null`
+if [ -n "$(env 'a'="() { echo x;}" $bash -c a 2>/dev/null)" ]; then
+       echo -e "\033[91mVariable function parser active, maybe vulnerable to unknown parser bugs\033[39m"
+       scary=1
+elif [ -n "$(env 'BASH_FUNC_a%%'="() { echo x;}" $bash -c a 2>/dev/null)" ]; then
+       echo -e "\033[92mVariable function parser pre/suffixed [%%, upstream], bugs not exploitable\033[39m"
+       scary=0
+elif [ -n "$(env 'BASH_FUNC_a()'="() { echo x;}" $bash -c a 2>/dev/null)" ]; then
+       echo -e "\033[92mVariable function parser pre/suffixed [(), redhat], bugs not exploitable\033[39m"
+       scary=0
+elif [ -n "$(env '__BASH_FUNC<a>()'="() { echo x;}" $bash -c a 2>/dev/null)" ]; then
+       echo -e "\033[92mVariable function parser pre/suffixed [__BASH_FUNC<..>(), apple], bugs not exploitable\033[39m"
+       scary=0
+else
+       echo -e "\033[92mVariable function parser inactive, bugs not exploitable\033[39m"
+       scary=0
+fi
+
+
+r=`env x="() { :; }; echo x" $bash -c "" 2>/dev/null`
+if [ -n "$r" ]; then
+       warn "CVE-2014-6271 (original shellshock)"
+else
+       good "CVE-2014-6271 (original shellshock)"
+fi
+
+pushd $tmpdir > /dev/null
+env x='() { function a a>\' $bash -c echo 2>/dev/null > /dev/null
+if [ -e echo ]; then
+       warn "CVE-2014-7169 (taviso bug)"
+else
+       good "CVE-2014-7169 (taviso bug)"
+fi
+popd > /dev/null
+
+$($bash -c "true $(printf '<<EOF %.0s' 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80)" 2>$tmpdir/bashcheck.tmp)
+ret=$?
+grep AddressSanitizer $tmpdir/bashcheck.tmp > /dev/null
+if [ $? == 0 ] || [ $ret == 139 ]; then
+       warn "CVE-2014-7186 (redir_stack bug)"
+else
+       good "CVE-2014-7186 (redir_stack bug)"
+fi
+
+
+$bash -c "`for i in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200; do echo -n "for x$i in; do :;"; done; for i in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200; do echo -n "done;";done`" 2>/dev/null
+if [ $? != 0 ]; then
+       warn "CVE-2014-7187 (nested loops off by one)"
+else
+       echo -e "\033[96mTest for CVE-2014-7187 not reliable without address sanitizer\033[39m"
+fi
+
+$($bash -c "f(){ x(){ _;};x(){ _;}<<a;}" 2>/dev/null)
+if [ $? != 0 ]; then
+       warn "CVE-2014-6277 (lcamtuf bug #1)"
+else
+       good "CVE-2014-6277 (lcamtuf bug #1)"
+fi
+
+if [ -n "$(env x='() { _;}>_[$($())] { echo x;}' $bash -c : 2>/dev/null)" ]; then
+       warn "CVE-2014-6278 (lcamtuf bug #2)"
+elif [ -n "$(env BASH_FUNC_x%%='() { _;}>_[$($())] { echo x;}' $bash -c : 2>/dev/null)" ]; then
+       warn "CVE-2014-6278 (lcamtuf bug #2)"
+elif [ -n "$(env 'BASH_FUNC_x()'='() { _;}>_[$($())] { echo x;}' $bash -c : 2>/dev/null)" ]; then
+       warn "CVE-2014-6278 (lcamtuf bug #2)"
+else
+       good "CVE-2014-6278 (lcamtuf bug #2)"
+fi
+
+rm -rf $tmpdir